;________________________________________________________________________
;
;                           S E R I A L . A S M
;________________________________________________________________________
;
; by Colin Buckup N5GG n5gg@hotmail.com April 00
; based on the original code PICE90 for Position Sending with the PIC-E
; previously written by Byon Garrabrant  N6BG  byon@mail.com  Feb 99
; All copyrights that apply do Byon's code also apply to this version
;________________________________________________________________________
;
; Revision
; v 1.0 - 04/06/00 - Colin
;
;________________________________________________________________________

	cblock				; variables
		serialDelayCount
		serialCount
		serialData
	endc
;________________________________________________________________________

#define		SERIAL_IN	PORTA, 0
#define		SERIAL_OUT	PORTA, 1

; DELAY_TIME should be (ClockSpeed/4/SerialSpeed-14)/3
; 4MHz 9600 baud would be (4000000/4/9600-14)/3 = 30
; 4MHz 2400=134 4800=65 9600=30 19200=13 38400=4 57600=1

; 10Mhz  4800=169
DELAY_TIME	equ	D'169'

;________________________________________________________________________

serialDelayThird
	movlw	DELAY_TIME/3		
	movwf	serialDelayCount	; only count 1/3
	goto	serialDelayLoop		; use routine below
serialDelay
	movlw	DELAY_TIME		
	movwf	serialDelayCount	; Count down from DELAY_TIME
	nop				; Helps with high speed
serialDelayLoop
	decfsz	serialDelayCount, F	; Countdown
	 goto	serialDelayLoop		; keep counting
	return				; done
;________________________________________________________________________

serialInit
	bsf	STATUS, RP0		; Select Bank 1
	bsf	SERIAL_IN		; Setup input
	bcf	SERIAL_OUT		; Setup output
	bcf	STATUS, RP0		; Select Bank 0
	return

;________________________________________________________________________

serialReceive
	btfss	SERIAL_IN		; Check for Start bit
	 retlw	0			; not receiving now
	movlw	D'9'			
	movwf	serialCount		; gonna read 9 bits
	call	serialDelayThird	; skip third a bit
serialReceiveLoop
	clrc				; assume clear carry
	btfss	SERIAL_IN		; if receiving 0
	 setc				; set carry
	rrf	serialData, F		; roll serialData bits	
	call	serialDelay		; delay
	nop				; keep timing w/ transmit
	decfsz	serialCount, F		; if not complete
	 goto	serialReceiveLoop	; loop back for more
	movfw	serialData		; return the data
	return
;________________________________________________________________________

